import Head from 'next/head'
import type { GetServerSideProps, NextPage } from 'next'
import { useState } from 'react'

import {
  PagesContainer,
  Searchbar,
  CardContainer,
  Pagination,
  Loader,
} from '../../components'
import { UsersProps, User } from '../../types'
import { UserCard } from '../../components/UsersPage'
import { useSearch, usePagination } from '../../hooks'
import { BASE_URL } from '../../const'

const Users: NextPage<UsersProps> = ({ users }) => {
  const [userToSearch, setUserToSearch] = useState<string>()
  const { currentPage, setCurrentPage } = usePagination()
  const { data, loading, totalDataNumber } = useSearch<User[]>(
    userToSearch
      ? `${BASE_URL}/search/users?q=${userToSearch}&page=${currentPage}`
      : undefined
  )

  return (
    <>
      <Head>
        <title>Zebrands</title>
        <meta name="description" content="Generated by create next app" />
        <link rel="logo" href="/logo.svg" />
      </Head>

      <PagesContainer>
        <Searchbar onChange={(user) => setUserToSearch(user)} />
        <CardContainer>
          {loading ? <Loader /> : <UserCard users={data ?? users} />}
        </CardContainer>
        <Pagination
          totalData={totalDataNumber}
          currentPage={currentPage}
          onHandlePaginate={setCurrentPage}
        />
      </PagesContainer>
    </>
  )
}

export default Users

export const getServerSideProps: GetServerSideProps = async () => {
  try {
    const apiResponse = await fetch(`${BASE_URL}/users`)
    const users: User[] = await apiResponse.json()
    return {
      props: {
        users,
      },
    }
  } catch (e) {
    return {
      props: {
        users: [],
      },
    }
  }
}
